import { ViewBase } from '../../libappbase/viewbase';
import { ButtonParametersContextMenuItem } from '../actionbarpages/abp.data';
import { AppMP } from '../appmp';
import { FormCurrency } from '../forms/form.currency';
import { FormCurrencyRate } from '../forms/form.currencyrate';
import { FormCurrencyRateChart } from '../forms/form.currencyratechart';

/**
 * Data > Parameters > Currencies view.
 */
export class ViewCurrency extends ViewBase {
  public readonly name = 'View Currencies definitions';
  public readonly viewPath = 'Data > Parameters > Currencies';

  // Forms
  public formCurrency = new FormCurrency();
  public formCurrencyRate = new FormCurrencyRate();
  public formCurrencyRateChart = new FormCurrencyRateChart();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    // wait until abp Data is visible
    await appMP.abpData.isVisible();
    // Open Data action bar page
    await appMP.abpData.click();
    // Click on the Parameters button and select Currencies from dropdown
    await appMP.abpData.btnParameters.clickDropdownAndSelectMenu(ButtonParametersContextMenuItem.Currencies);
    // Wait until forms in view are present
    await this.formCurrency.waitUntilPresent();
    await this.formCurrencyRate.waitUntilPresent();
    await this.formCurrencyRateChart.waitUntilPresent();
  }
}
